VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAddOrder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function AddNewOrder(ByVal strServer As String, _
                            ByVal strUser As String, _
                            ByVal strPwd As String, _
                            ByVal lngCustID As Long, _
                            ByVal datOrderDate As Date, _
                            ByVal datRequiredDate As Date, _
                            ByVal blnPartialShip As Boolean, _
                            ByVal bytCardID As Byte, _
                            ByVal bytShipToID As Byte, _
                            ByVal bytShipTypeID As Byte, _
                            ByVal blnSalesTax As Boolean) As Long
   
   'Creates and passes a connection to AddNewOrderConn
   Dim cnnOrder As New ADODB.Connection
   Dim strOrderConn As String
   
   On Error Resume Next
   
   strOrderConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
      ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
   cnnOrder.Open strOrderConn
   If Err.Number <> 0 Then
      'Connection failed
      AddNewOrder = -1
      Exit Function
   End If
   AddNewOrder = AddNewOrderConn(cnnOrder, lngCustID, datOrderDate, _
                 datRequiredDate, blnPartialShip, bytCardID, _
                 bytShipToID, bytShipTypeID, blnSalesTax)
                 
   cnnOrder.Close
   Set cnnOrder = Nothing
End Function

Public Function AddNewOrderConn(ByRef cnnOrder As ADODB.Connection, _
                                ByVal lngCustID As Long, _
                                ByVal datOrderDate As Date, _
                                ByVal datRequiredDate As Date, _
                                ByVal blnPartialShip As Boolean, _
                                ByVal bytCardID As Byte, _
                                ByVal bytShipToID As Byte, _
                                ByVal bytShipTypeID As Byte, _
                                ByVal blnSalesTax As Boolean) As Long
   
   'Adds a new order; returns OrderID if successful, error code if not.
   Dim rstOrder As New ADODB.Recordset
   Dim strSQL As String
   Dim strPartialShip As String
   Dim strSalesTax As String
   Dim lngReccnt As Long
   
   On Error Resume Next
   
   If blnPartialShip Then
      strPartialShip = "1"
   Else
      strPartialShip = "0"
   End If
   If blnSalesTax Then
      strSalesTax = "1"
   Else
      strSalesTax = "0"
   End If
   
   strSQL = "INSERT Orders(CustID, OrderDate, RequiredShipDate, " & _
      "PartialShipOK, CardID, ShipTypeID, SalesTaxApplies, StatusID) " & _
      "VALUES(" & lngCustID & ", '" & datOrderDate & "' , "
   If Year(datRequiredDate) = 1899 Then
      strSQL = strSQL & "NULL"
   Else
      strSQL = strSQL & "'" & datRequiredDate & "'"
   End If
   strSQL = strSQL & ", " & strPartialShip & ", " & bytCardID & ", " & _
      bytShipTypeID & ", " & strSalesTax & ", 11)"
      
   cnnOrder.Execute strSQL, lngReccnt, adCmdText
   If Err.Number <> 0 Then
      'Execution failed
      AddNewOrderConn = -2
      Exit Function
   End If
   
   If CLng(lngReccnt) > 0 Then
      'Get the identity value for the connection
      strSQL = "SELECT @@identity"
      Set rstOrder = cnnOrder.Execute(strSQL, , adCmdText)
      If Err.Number <> 0 Then
         'Execution failed
         AddNewOrderConn = -3
         Exit Function
      End If
      
      With rstOrder
         If .EOF Then
            'Couldn't find the order
            AddNewOrderConn = -4
         Else
            'Get the OrderID
            AddNewOrderConn = CLng(.Fields(0).Value)
         End If
         .Close
         Set rstOrder = Nothing
      End With
   Else
      'Didn't add order
      AddNewOrderConn = -1
   End If
End Function

Public Function AddLineItem(ByVal strServer As String, _
                            ByVal strUser As String, _
                            ByVal strPwd As String, _
                            ByVal lngOrderID As Long, _
                            ByVal bytItemID As Byte, _
                            ByVal bytQuan As Byte, _
                            ByVal strSKU As String, _
                            ByVal bytOutsourced As Byte, _
                            ByVal curUnitPrice As Currency, _
                            ByVal sngDiscount As Single, _
                            ByVal curAllowance As Currency, _
                            ByVal bytAllowType As Byte) As Currency
                             
   'Creates and passes a connection to AddLineItemConn
   Dim cnnItem As New ADODB.Connection
   Dim strItemConn As String
   
   On Error Resume Next
   
   strItemConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
      ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
   cnnItem.Open strItemConn
   
   If Err.Number <> 0 Then
      'Connection failed error
      AddLineItem = -1
      Exit Function
   End If
   
   'Pass the connection to the operative function
   AddLineItem = AddLineItemConn(cnnItem, lngOrderID, bytItemID, _
                                 bytQuan, strSKU, bytOutsourced, curUnitPrice, _
                                 sngDiscount, curAllowance, bytAllowType)
   If Err.Number <> 0 Then
      'Function call failed
      AddLineItem = -2
   End If
   cnnItem.Close
   Set cnnItem = Nothing
End Function
   
Public Function AddLineItemConn(ByRef cnnItem As ADODB.Connection, _
                                ByVal lngOrderID As Long, _
                                ByVal bytItemID As Byte, _
                                ByVal bytQuan As Byte, _
                                ByVal strSKU As String, _
                                ByVal bytOutsourced As Byte, _
                                ByVal curUnitPrice As Currency, _
                                ByVal sngDiscount As Single, _
                                ByVal curAllowance As Currency, _
                                ByVal bytAllowType As Byte) As Currency
   
   Dim strSQL As String
   Dim lngReccnt As Long
   
   On Error Resume Next
   
   strSQL = "INSERT LineItems VALUES(" & CStr(lngOrderID) & ", " & _
            CStr(bytItemID) & ", " & CStr(bytQuan) & ", '" & _
            strSKU & "', " & bytOutsourced & ", " & curUnitPrice & ", " & _
            sngDiscount & ", " & curAllowance & ", " & bytAllowType & ", 11, NULL, 0)"
            
   cnnItem.Execute strSQL, lngReccnt, adCmdText
   If Err.Number <> 0 Then
      AddLineItemConn = -3
   End If
   If CLng(lngReccnt) > 0 Then
      AddLineItemConn = curUnitPrice * CCur(bytQuan)
   Else
      'Line item not added
      AddLineItemConn = 0
   End If
End Function

