VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAlphaInventory"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function CheckStock(ByVal strServer As String, _
                           ByVal strDatabase As String, _
                           ByVal strUser As String, _
                           ByVal strPassword As String, _
                           ByVal strSKU As String, _
                           ByVal blnXML As Boolean) As String
   
   'Query distributor CheckStock
   'Returns cookie-formatted string with quantity on hand
   'This function is the same for each distributor
   
   Dim cnnInventory As New ADODB.Connection
   Dim rstInventory As New ADODB.Recordset
   Dim rstAllowDisc As New ADODB.Recordset
   Dim strConn As String
   Dim strSQL As String
   Dim strXML As String
   Dim intCol As Integer
   
   'On Error Resume Next
   strConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
             ";Initial Catalog=" & strDatabase & ";UID=" & _
             strUser & ";PWD=" & strPassword
   cnnInventory.Open strConn
   
   If Err.Number = 0 Then
      'Get the product data
      strSQL = "SELECT * FROM Products WHERE SKU = '" & strSKU & "'"
      Set rstInventory = cnnInventory.Execute(strSQL, , adCmdText)
      With rstInventory
         If .EOF Then
            CheckStock = "Error: " & strDatabase & " doesn't recognize SKU " & strSKU
         Else
            If blnXML Then
               'Serialize report
               strXML = "<" & strDatabase & "Inventory>" & vbCrLf
               For intCol = 0 To 4
                  strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & _
                           ">" & CStr(.Fields(intCol).Value) & "</" & _
                           CStr(.Fields(intCol).Name) & ">" & vbCrLf
               Next intCol
               For intCol = 5 To 7
                  strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & ">"
                  If IsNull(.Fields(intCol).Value) Then
                     'Do nothing
                  ElseIf intCol = 7 Then
                     'Weight
                     strXML = strXML & CStr(.Fields(intCol).Value) & " lbs"
                  Else
                     'Money
                     strXML = strXML & Format$(CCur(.Fields(intCol).Value), "$#,##0.00")
                  End If
                  strXML = strXML & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
               Next intCol
               For intCol = 9 To 12
                  strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & ">"
                  'AllowanceID
                  If CCur(.Fields(9).Value > 0) Then
                     If intCol = 9 Then
                        strXML = strXML & CStr(.Fields(9).Value)
                     ElseIf intCol = 10 Then
                        strXML = strXML & Format$(CCur(.Fields(10).Value), "$#,##0.00")
                     End If
                  End If
                  If CByte(.Fields(11).Value) > 0 Then
                     If intCol = 11 Then
                        strXML = strXML & CStr(.Fields(11).Value)
                     ElseIf intCol = 12 Then
                        strXML = strXML & Format$(CSng(.Fields(12).Value), "#0.0%")
                     End If
                  End If
                  strXML = strXML & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                  If intCol = 10 Or intCol = 12 Then
                     'Add the allowance type element
                     If intCol = 10 Then
                        strXML = strXML & "   <AllowanceType>"
                     Else
                        strXML = strXML & "   <DiscountType>"
                     End If
                     If (CByte(.Fields(9).Value) > 0 And intCol = 10) Or (CByte(.Fields(11).Value) > 0 And intCol = 12) Then
                        strSQL = "SELECT * FROM AllowancesDiscounts WHERE AllowDiscID = " & CStr(.Fields(intCol - 1).Value)
                        Set rstAllowDisc = cnnInventory.Execute(strSQL, , adCmdText)
                        If Not rstAllowDisc.EOF Then
                           strXML = strXML & CStr(rstAllowDisc.Fields(1).Value)
                        End If
                      End If
                     If intCol = 10 Then
                        strXML = strXML & "</AllowanceType>"
                     Else
                        strXML = strXML & "</DiscountType>"
                     End If
                     strXML = strXML & vbCrLf
                  End If
               Next intCol
               intCol = 8
               strXML = strXML & "   <" & CStr(.Fields(intCol).Name) & _
                        "InStock>" & CStr(.Fields(intCol).Value) & "</" & _
                        CStr(.Fields(intCol).Name) & "InStock>" & vbCrLf
               strXML = strXML & "   <DateTime>" & CStr(Now) & "</DateTime>" & vbCrLf
               strXML = strXML & "</" & strDatabase & "Inventory>" & vbCrLf
               CheckStock = strXML
            Else
               'Return string is cookie format
               CheckStock = strDatabase & " CheckStock for SKU=" & strSKU & _
                           ";Category=" & CStr(.Fields(1).Value) & ";Brand=" & _
                           CStr(.Fields(2).Value) & ";Model=" & CStr(.Fields(3).Value) & _
                           ";Description=" & CStr(.Fields(4).Value) & ";"
               If Not IsNull(.Fields(5).Value) Then
                  CheckStock = CheckStock & "MSRP=" & Format$(CCur(.Fields(5).Value), "$#,##0.00") & ";"
               End If
               CheckStock = CheckStock & "NetPrice=" & Format$(CCur(.Fields(6).Value), "$#,##0.00") & _
                  ";ShipWeight=" & CStr(.Fields(7).Value) & " lbs"
               If CByte(.Fields(9).Value) > 0 Then
                  strSQL = "SELECT * FROM AllowancesDiscounts WHERE AllowDiscID = " & CStr(.Fields(9).Value)
                  Set rstAllowDisc = cnnInventory.Execute(strSQL, , adCmdText)
                  If rstAllowDisc.EOF Then
                     'Not a critical error
                  Else
                     CheckStock = CheckStock & ";AllowanceFor=" & CStr(rstAllowDisc.Fields(1).Value) & _
                        ";Amount=" & Format$(CCur(.Fields(10).Value), "$#,##0.00")
                  End If
                  rstAllowDisc.Close
               End If
               If CByte(.Fields(11).Value) > 0 Then
                  strSQL = "SELECT * FROM AllowancesDiscounts WHERE AllowDiscID = " & CStr(.Fields(11).Value)
                  Set rstAllowDisc = cnnInventory.Execute(strSQL, , adCmdText)
                  If rstAllowDisc.EOF Then
                     'Not critical
                  Else
                     CheckStock = CheckStock & ";DiscountFor=" & CStr(rstAllowDisc.Fields(1).Value) & _
                        ";Percent=" & Format$(CSng(.Fields(10).Value), "#0.0%")
                  End If
                  rstAllowDisc.Close
               End If
               CheckStock = CheckStock & ";InStock=" & CStr(.Fields(8).Value)
            End If
         End If
      End With
   Else
      CheckStock = "Error: Can't connect to " & strDatabase
   End If
   rstInventory.Close
   Set rstInventory = Nothing
   Set rstAllowDisc = Nothing
   cnnInventory.Close
   Set cnnInventory = Nothing
End Function


