VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsFulfillOrder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function CheckOrCommit(ByVal strServer As String, _
                              ByVal strUser As String, _
                              ByVal strPwd As String, _
                              ByRef astrLineItems() As String, _
                              ByVal blnCommit As Boolean, _
                              ByVal blnUseWS As Boolean, _
                              ByVal blnUseOakLeaf As Boolean, _
                              ByVal blnUseIP As Boolean) As Integer
   
   'Check warehouse and distributor inventory level
   'Commit warehouse inventory if blnCommit is True
   
   Dim cnnStock As New ADODB.Connection
   Dim rstStock As New ADODB.Recordset
   Dim strStockConn As String
   Dim strSQL As String
   Dim strSQLItem As String
   Dim strSQLUpdate As String
   Dim bytItem As Byte
   Dim sngWeight As Single
   Dim curAmount As Currency
   Dim intInStock As Integer
   Dim lngReccnt As Long
   Dim strOutsource As String
   'Dim objSoapClient As New SoapClient
   Dim objSoapClient As Object
   
   On Error Resume Next
   
   strSQL = "SELECT NetPrice, ShipWeight, Outsourced, BeginningInventory, " & _
            "ReceivedInPeriod, ShippedInPeriod, CommittedNow FROM Products WHERE SKU = '"
   
   strStockConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
      ";Initial Catalog=OCE_Prod;UID=" & strUser & ";PWD=" & strPwd
   cnnStock.Open strStockConn
   If Err.Number <> 0 Then
      'Can't connect
      CheckOrCommit = -1
   End If
   With cnnStock
      If blnCommit Then
         .BeginTrans
      End If
      For bytItem = 0 To UBound(astrLineItems) - 1
         strSQLItem = strSQL & astrLineItems(bytItem, 0) & "'"
         Set rstStock = .Execute(strSQLItem, , adCmdText)
         If Err.Number <> 0 Then
            'Can't execute query
            CheckOrCommit = -1
            GoTo ExitCheckOrCommit
         End If
         With rstStock
            If .EOF Then
               'Can't find item
               CheckOrCommit = -3
               If blnCommit Then
                  cnnStock.RollbackTrans
               End If
               GoTo ExitCheckOrCommit
            Else
               If CBool(.Fields(2).Value) Then
                  'It's outsourced, return the DistID value
                  astrLineItems(bytItem, 2) = GetDistInventory(strServer, strUser, strPwd, _
                                              astrLineItems(bytItem, 0), astrLineItems(bytItem, 1), _
                                              blnUseWS, blnUseOakLeaf, blnUseIP)
               Else
                  'Get current stock (Beginning + Received - Shipped - Committed)
                  'Partial shipments make it possible to overcommit inventory (negative value)
                  intInStock = CInt(.Fields(3).Value) + CInt(.Fields(4).Value) _
                     - CInt(.Fields(5).Value) - CInt(.Fields(6).Value)
                  If intInStock >= CByte(astrLineItems(bytItem, 1)) Then
                     astrLineItems(bytItem, 2) = "Yes"
                  Else
                     astrLineItems(bytItem, 2) = "No"
                  End If
                  If blnCommit Then
                     'Commit the inventory
                     strSQLUpdate = "UPDATE Products SET CommittedNow = CommittedNow + " & astrLineItems(bytItem, 1) & _
                              "WHERE SKU = '" & astrLineItems(bytItem, 0) & "'"
                     cnnStock.Execute strSQLUpdate, lngReccnt, adCmdText
                     If Err.Number <> 0 Or lngReccnt <> 1 Then
                        'Unable to commit inventory
                        cnnStock.RollbackTrans
                        CheckOrCommit = -4
                        GoTo ExitCheckOrCommit
                     End If
                  End If
               End If
               'Weight per item
               astrLineItems(bytItem, 3) = CStr(.Fields(1).Value)
            End If
         End With
      Next bytItem
      If blnCommit Then
         'Commit the inventory
         .CommitTrans
      End If
   End With
   CheckOrCommit = CInt(bytItem)
   
ExitCheckOrCommit:
   'Standard cleanup
   With rstStock
      If .State = adStateOpen Then
         Close
      End If
   End With
   Set rstStock = Nothing
   With cnnStock
      If .State = adStateOpen Then
         Close
      End If
   End With
   Set cnnStock = Nothing
End Function

Private Function GetDistInventory(ByVal strProdServer As String, _
                                  ByVal strProdUser As String, _
                                  ByVal strProdPwd As String, _
                                  ByVal strSKU As String, _
                                  ByVal bytQuan As Byte, _
                                  ByVal blnUseWS As Boolean, _
                                  ByVal blnUseOakLeaf As Boolean, _
                                  ByVal blnUseIP As Boolean) As String
   
   'Check specified distributors for inventory of SKU
   Dim cnnProd As New ADODB.Connection
   Dim rstProd As New ADODB.Recordset
   Dim rstBrand As New ADODB.Recordset
   Dim rstDist As New ADODB.Recordset
   Dim docDist As New MSXML2.DOMDocument40
   Dim lstDist As MSXML2.IXMLDOMNodeList
   Dim nodDist As MSXML2.IXMLDOMNode
   
   Dim strProdConn As String
   Dim strSQL As String
   'Added fixed dimensions for Visual Basic .NET
   Dim astrResponse(3, 2) As String
   Dim bytDist As Byte
   Dim bytCtr As Byte
   Dim strDistConn As String
   Dim strServiceURL As String
   Dim strQuan As String
   'Dim objSoapClient As New SoapClient
   Dim objSoapClient As Object
   
   On Error Resume Next
   
   strProdConn = "Provider=SQLOLEDB;Data Source=" & strProdServer & _
      ";Initial Catalog=OCE_Prod;UID=" & strProdUser & ";PWD=" & strProdPwd
   cnnProd.Open strProdConn
   If Err.Number = 0 Then
      strSQL = "SELECT BrandID, Cost FROM Products WHERE SKU = '" & strSKU & "'"
      Set rstProd = cnnProd.Execute(strSQL, , adCmdText)
   
      If rstProd.EOF Then
         'Shouldn't occur
         astrResponse(bytDist, 1) = "NONE"
         astrResponse(bytDist, 2) = "Error: No record for SKU " & strSKU
      Else
         strSQL = "SELECT DistID FROM BrandDistributor WHERE BrandID = '" & CStr(rstProd.Fields(0).Value) & "'"
         Set rstBrand = cnnProd.Execute(strSQL, , adCmdText)
         With rstBrand
            If .EOF Then
               astrResponse(bytDist, 1) = "NONE"
               astrResponse(bytDist, 2) = "Error: No distributor for BrandID " & CStr(rstProd.Fields(0).Value)
            Else
               bytDist = 0
               Do Until .EOF
                  'Query each distributor
                  strSQL = "SELECT DistID, InventoryWS, ServerName, [Database], UserName, " & _
                           "Password, InventoryWS " & _
                           "FROM Distributors WHERE DistID = '" & CStr(.Fields(0).Value) & "'"
                  Set rstDist = cnnProd.Execute(strSQL, , adCmdText)
                  With rstDist
                     '1-based array
                     bytDist = bytDist + 1
                     If .EOF Then
                        'No distributor for this product
                        astrResponse(bytDist, 1) = "NONE"
                        astrResponse(bytDist, 2) = "Error: No distributor for SKU " & strSKU
                     Else
                        If blnUseOakLeaf Then
                           If blnUseIP Then
                              'Same IPs for all distributors
                              strServiceURL = "http://66.123.163.243/"
                           Else
                              strServiceURL = "http://www.oakleaf.ws/"
                           End If
                        Else
                           strServiceURL = "http://localhost/"
                        End If
                        astrResponse(bytDist, 1) = CStr(.Fields(0).Value)
                        Select Case CStr(.Fields(0).Value)
                           Case "ALPH"
                              If blnUseWS Then
                                 strServiceURL = strServiceURL & "Alpha/AlphaDist.wsdl"
                              Else
                                 Dim objAlphaInv As New clsAlphaDist
                                 astrResponse(bytDist, 2) = objAlphaInv.CheckStock(CStr(.Fields(2).Value), _
                                     CStr(.Fields(3).Value), CStr(.Fields(4).Value), _
                                     CStr(.Fields(5).Value), strSKU, False)
                                 Set objAlphaInv = Nothing
                              End If
                           Case "BETA"
                              If blnUseWS Then
                                 strServiceURL = strServiceURL & "Beta/BetaDist.wsdl"
                              Else
                                 Dim objBetaInv As New clsBetaDist
                                 astrResponse(bytDist, 2) = objBetaInv.CheckStock(CStr(.Fields(2).Value), _
                                     CStr(.Fields(3).Value), CStr(.Fields(4).Value), _
                                     CStr(.Fields(5).Value), strSKU, False)
                                 Set objBetaInv = Nothing
                              End If
                           Case "GAMM"
                              If blnUseWS Then
                                 strServiceURL = strServiceURL & "Gamma/GammaDist.wsdl"
                              Else
                                 Dim objGammaInv As New clsGammaDist
                                 astrResponse(bytDist, 2) = objGammaInv.CheckStock(CStr(.Fields(2).Value), _
                                     CStr(.Fields(3).Value), CStr(.Fields(4).Value), _
                                     CStr(.Fields(5).Value), strSKU, False)
                                 Set objGammaInv = Nothing
                              End If
                        End Select
                        If blnUseWS Then
                           'Late binding for multi-purpose use
                           Set objSoapClient = CreateObject("MSSOAP.SoapClient")
                           Call objSoapClient.mssoapinit(strServiceURL)
                           'ToDo: Change to XML return string after testing
                           astrResponse(bytDist, 2) = objSoapClient.CheckStock(CStr(.Fields(2).Value), _
                               CStr(.Fields(3).Value), CStr(.Fields(4).Value), _
                               CStr(.Fields(5).Value), strSKU, True)
                           If Len(objSoapClient.faultstring) Then
                              astrResponse(bytDist, 1) = "NONE"
                              astrResponse(bytDist, 2) = "Error: " & objSoapClient.faultstring
                           End If
                           Set objSoapClient = Nothing
                        End If
                     End If
                     If Err.Number <> 0 And astrResponse(bytDist, 1) <> "NONE" Then
                        astrResponse(bytDist, 1) = "NONE"
                        astrResponse(bytDist, 2) = "ERROR: " & Err.Description
                     End If
                     .Close
                  End With
                  .MoveNext
               Loop
               'ToDo: Calculate the best price, including discounts and allowances
               'Temporarily, choose the distributor with the largest inventory
               If bytDist > 0 Then
                  For bytCtr = 1 To bytDist
                     If blnUseWS Then
                        With docDist
                           'Load the document
                           .loadXML astrResponse(bytCtr, 2)
                           If .parseError.errorCode = 0 Then
                              'Get quantity
                              Set lstDist = .getElementsByTagName("QuantityInStock")
                              If lstDist.length > 0 Then
                                 Set nodDist = lstDist(0)
                                 astrResponse(bytCtr, 0) = nodDist.Text
                              Else
                                 'Error
                              End If
                           Else
                              'Parse error
                           End If
                        End With
                     Else
                        If InStr(astrResponse(bytCtr, 2), "InStock") > 0 Then
                           strQuan = astrResponse(bytCtr, 2)
                           strQuan = Mid$(strQuan, InStrRev(strQuan, "=") + 1)
                           astrResponse(bytCtr, 0) = strQuan
                        Else
                           'error
                        End If
                     End If
                  Next bytCtr
                  strQuan = "0"
                  If bytDist > 1 Then
                     For bytCtr = 1 To bytDist
                        'Get the largest quantity
                        If Val(astrResponse(bytCtr, 0)) > Val(strQuan) Then
                           strQuan = astrResponse(bytCtr, 0)
                        End If
                     Next bytCtr
                     For bytCtr = 1 To bytDist
                        'Find that distributor
                        If Val(astrResponse(bytCtr, 0)) = strQuan Then
                           If Val(strQuan) > 0 Then
                              GetDistInventory = astrResponse(bytCtr, 1)
                           Else
                              GetDistInventory = "No"
                           End If
                        End If
                     Next bytCtr
                  Else
                     If Val(astrResponse(bytDist, 0)) > 0 Then
                        GetDistInventory = astrResponse(bytDist, 1)
                     Else
                        GetDistInventory = "No"
                     End If
                  End If
               Else
                  'No distributor records found
                  GetDistInventory = "No"
               End If
            End If
         End With
      End If
   Else
      GetDistInventory = "No"
   End If
     
   'Cleanup
   Set docDist = Nothing
   Set lstDist = Nothing
   Set nodDist = Nothing
   
   With rstProd
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstProd = Nothing
   With rstBrand
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstBrand = Nothing
   With rstDist
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstDist = Nothing
   With cnnProd
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnProd = Nothing
End Function

Public Function ShipItems(ByVal strCustServer As String, _
                          ByVal strCustUser As String, _
                          ByVal strCustPwd As String, _
                          ByVal strProdServer As String, _
                          ByVal strProdUser As String, _
                          ByVal strProdPwd As String, _
                          ByVal strNetServer As String, _
                          ByVal strNetUser As String, _
                          ByVal strNetPwd As String, _
                          ByVal strNetIP As String, _
                          ByVal lngOrderID As Long, _
                          ByVal strCardNumber As String, _
                          ByVal blnGetUPSCharge As Boolean, _
                          ByVal blnUseWS As Boolean, _
                          ByVal blnUseOakLeaf As Boolean, _
                          ByVal blnUseIP As Boolean) As String
   
   'Ship in-stock items to customer, change committed to shipped
   'Mark line items not shipped as backordered
   'Prepare invoice(s) to include with shipment(s)
   'Charge card (remove hold for items shipped)
   
   Dim cnnCust As New ADODB.Connection
   Dim cnnProd As New ADODB.Connection
   Dim cnnInvoice As New ADODB.Connection
   Dim cnnPurchOrd As New ADODB.Connection
   Dim rstCust As New ADODB.Recordset
   Dim rstShipTo As New ADODB.Recordset
   Dim rstOrder As New ADODB.Recordset
   Dim rstItems As New ADODB.Recordset
   Dim rstProd As New ADODB.Recordset
   Dim rstInvoice As New ADODB.Recordset
   Dim rstTemp As New ADODB.Recordset
   
   Dim OmegaBank As New clsOmegaBank
   Dim objOmegaBank As Object
   'Dim objOmegaBank As New SoapClient
   
   Dim strCustConn As String
   Dim strProdConn As String
   Dim strSQL As String
   Dim blnAllInStock As Boolean
   Dim lngReccnt As Long
   'Dimensions are arbitrary
   Dim acurItemsTotal(10) As Currency
   Dim acurSalesTax(10) As Currency
   Dim acurFreight(10) As Currency
   Dim astrTrackingID(10) As String
   Dim astrShipTypeID(10) As String
   Dim acurOrderTotal(10) As Currency
   'Added dimension for Visual Basic .NET
   Dim alngPurchInvID(10, 3) As Long
   Dim curOrderTotal As Currency
   Dim bytOurInvNum As Byte
   Dim bytInv As Byte
   Dim blnUPSAndTruck As Boolean
   Dim lngTransactID As Long
   Dim strCharge As String
   Dim strStatus As String
   Dim strMsg As String
   Dim strTRID As String
   Dim bytNumInvoices As Byte
   Dim strPartShip As String
   Dim strErrMsg As String
   Dim intSuspend As Integer
   Dim lngPurchID As Long
   Dim intCol As Integer
   Dim strXML As String
   Dim intItems As Integer
   Dim bytItem As Byte
   Dim strDistID As String
   Dim strDistList As String
   Dim lngInvoiceID As Long
   Dim strServer As String
   Dim strURL As String
   
   'Initial values
   blnAllInStock = True
   blnUPSAndTruck = False
   strPartShip = "0"
   
   On Error Resume Next
   
   'Initial connections
   strCustConn = "Provider=SQLOLEDB;Data Source=" & strCustServer & _
      ";Initial Catalog=OCE_Cust;UID=" & strCustUser & ";PWD=" & strCustPwd
   cnnCust.Open strCustConn
   
   strProdConn = "Provider=SQLOLEDB;Data Source=" & strProdServer & _
      ";Initial Catalog=OCE_Prod;UID=" & strProdUser & ";PWD=" & strProdPwd
   cnnProd.Open strProdConn
   
   If Err.Number <> 0 Then
      strErrMsg = "Can't open connections"
      GoTo ExitShipItems
   End If
   
   With cnnCust
      'Get the full Orders record
      strSQL = "SELECT * FROM Orders WHERE OrderID = " & lngOrderID
      Set rstOrder = .Execute(strSQL, , adCmdText)
      If rstOrder.EOF Then
         strErrMsg = "Order not found"
         GoTo ExitShipItems
      Else
         If IsNull(rstOrder.Fields("CCTransactionID").Value) Then
            strErrMsg = "No transaction ID"
            GoTo ExitShipItems
         Else
            lngTransactID = CLng(rstOrder.Fields("CCTransactionID").Value)
            'Get the LineItems records
            strSQL = "SELECT * FROM LineItems WHERE OrderID = " & CStr(lngOrderID)
            Set rstItems = .Execute(strSQL, , adCmdText)
            If rstItems.EOF Then
               strErrMsg = "No line items found"
               GoTo ExitShipItems
            Else
               'Get the full Customers record (to print invoice)
               strSQL = "SELECT * FROM Customers WHERE CustID = " & _
                        CStr(rstOrder.Fields("CustID").Value)
               Set rstCust = .Execute(strSQL, , adCmdText)
               If rstCust.EOF Then
                  strErrMsg = "No customer record found"
                  GoTo ExitShipItems
               End If
               strSQL = "SELECT * FROM ShipAddresses WHERE CustID = " & _
                  CStr(rstOrder.Fields("CustID").Value) & " AND ShipToID = " & _
                  CStr(rstOrder.Fields("ShipToID").Value)
               Set rstShipTo = .Execute(strSQL, , adCmdText)
               If rstShipTo.EOF Then
                  strErrMsg = "No customer shipping address record found"
                  GoTo ExitShipItems
               End If
            End If
         End If
      End If
   End With
   
   'Field names used below for readability
   bytNumInvoices = 0
   bytOurInvNum = 0
   With rstItems
      Do Until .EOF
         'Update line items records and inventory record
         strStatus = ""
         strSQL = "SELECT ShipWeight, Cost FROM Products WHERE SKU = '" & CStr(.Fields("SKU").Value) & "'"
         Set rstProd = cnnProd.Execute(strSQL, , adCmdText)
         If rstProd.EOF Then
            strErrMsg = "No product record found"
            GoTo ExitShipItems
         End If
         
         If CByte(.Fields("StatusID").Value) = 31 And Not CBool(.Fields("Outsourced").Value) Then
            'Order to Warehouse (Commit); change status to 41 - Item shipped
            strSQL = "UPDATE LineItems SET StatusID = 41 " & _
                     "WHERE OrderID = " & CStr(lngOrderID) & _
                     " AND ItemID = " & CStr(.Fields("ItemID").Value)
            cnnCust.Execute strSQL, lngReccnt, adCmdText
            If CLng(lngReccnt) = 1 Then
               strStatus = "41"
               'Move committed inventory to shipped status
               strSQL = "UPDATE Products SET CommittedNow = CommittedNow - " & _
               CStr(.Fields("Quantity").Value) & ", ShippedInPeriod = ShippedInPeriod + " & _
               CStr(.Fields("Quantity").Value) & " WHERE SKU = '" & CStr(.Fields("SKU").Value) & "'"
               cnnProd.Execute strSQL, lngReccnt, adCmdText
               
               'One invoice for all items in stock
               If bytOurInvNum = 0 Then
                  bytNumInvoices = bytNumInvoices + 1
                  bytOurInvNum = bytNumInvoices
               End If
            Else
               strErrMsg = "Committed to ship update failed"
               GoTo ExitShipItems
            End If
         Else
            If CBool(.Fields("Outsourced").Value) Then
               'Todo: This needs a fixup in cmdIssueHolds for individual line item status
               'Change status to 42 - Shipped by Distributor (separate invoice)
               strSQL = "UPDATE LineItems SET StatusID = 42 "
               strStatus = "42"
               If InStr(strDistList, CStr(.Fields("OrderFrom").Value)) = 0 Then
                  'Another invoice required
                  bytNumInvoices = bytNumInvoices + 1
               End If
            Else
               'Change status to 40 - Item Backordered
               blnAllInStock = False
               strPartShip = "1"
               strSQL = "UPDATE LineItems SET StatusID = 40 "
               strStatus = "40"
            End If
            strSQL = strSQL & "WHERE OrderID = " & CStr(lngOrderID) & _
                              " AND ItemID = " & CStr(.Fields("ItemID").Value)
            cnnCust.Execute strSQL, lngReccnt, adCmdText
            If CLng(lngReccnt) <> 1 Then
               strErrMsg = "Update line item status failed"
               GoTo ExitShipItems
            End If
         End If
         
         If strStatus = "41" Or strStatus = "42" Then
            'Get current items total
            acurItemsTotal(bytNumInvoices) = acurItemsTotal(bytNumInvoices) + _
               (CCur(CInt(.Fields("Quantity").Value) * _
                CCur(.Fields("UnitPrice").Value)))
            
            'Get sales tax
            If CBool(rstOrder.Fields("SalesTaxApplies")) Then
               acurSalesTax(bytNumInvoices) = CCur(Round(CCur(0.06) * acurItemsTotal(bytNumInvoices), 2))
            Else
               acurSalesTax(bytNumInvoices) = 0
            End If
            
            'Get freight cost
            acurFreight(bytNumInvoices) = acurFreight(bytNumInvoices) + _
               GetItemFreight(CStr(rstCust.Fields("ZIPCode").Value), _
               CSng(rstProd.Fields("ShipWeight").Value), blnGetUPSCharge)
            
            'Set ship type and tracking IDs
            Randomize
            If CInt(rstProd.Fields("ShipWeight").Value) > 50 Then
               'Truck
               astrShipTypeID(bytNumInvoices) = "33"
               astrTrackingID(bytNumInvoices) = astrTrackingID(bytNumInvoices) & _
                  CStr(CLng(10000000 * Rnd)) & " "
            Else
               astrShipTypeID(bytNumInvoices) = "11"
               astrTrackingID(bytNumInvoices) = astrTrackingID(bytNumInvoices) & _
                  "1Z" & CStr(CLng(10000000 * Rnd)) & " "
            End If
         End If
         
         If strStatus = "42" Then
            'Outsourced
            If lngPurchID = 0 Or (lngPurchID > 0 And InStr(strDistList, CStr(.Fields("OrderFrom").Value)) = 0) Then
               'Generate a purchase order to the distributor (transaction)
               'ToDo: If more than one order is outsourced, rerun an inventory
               '      test at the same distributor to consolidate the shipment
               cnnPurchOrd.Open strProdConn
               cnnPurchOrd.BeginTrans
               strDistID = CStr(.Fields("OrderFrom").Value)
               strSQL = "INSERT PurchaseOrders(OrderDate, DistID, ShipToCustomer, ReferenceID, " & _
                        "RequiredShipDate, ShipName, ShipAddress, ShipCity, ShipState, " & _
                        "ShipZIPCode, ShipPhone, ShipByID, PartialShipOK) VALUES('" & _
                        CStr(Now) & "', '" & strDistID & "', 1, " & CStr(lngOrderID) & ", '" & _
                        CStr(Now) & "', '" & CStr(rstShipTo.Fields(2).Value) & "', '" & _
                        CStr(rstShipTo.Fields(3).Value) & "', '" & CStr(rstShipTo.Fields(4).Value) & "', '" & _
                        CStr(rstShipTo.Fields(5).Value) & "', '" & CStr(rstShipTo.Fields(6).Value) & "', '" & _
                        CStr(rstCust.Fields("Phone").Value) & "', " & astrShipTypeID(bytNumInvoices) & ", 0)"
               cnnPurchOrd.Execute strSQL, lngReccnt, adCmdText
               If CLng(lngReccnt) = 0 Then
                  cnnPurchOrd.RollbackTrans
               Else
                  'Get the PO number
                  strSQL = "SELECT @@identity"
                  Set rstTemp = cnnPurchOrd.Execute(strSQL, , adCmdText)
                  If .EOF Then
                     cnnPurchOrd.RollbackTrans
                     'Mark the line item bad
                     strSQL = "UPDATE LineItems SET StatusID = 99 "
                     strStatus = "99"
                  Else
                     'Add the line item (most orders have only one outsourced item)
                     lngPurchID = CLng(rstTemp.Fields(0).Value)
                     alngPurchInvID(bytNumInvoices, 1) = lngPurchID
                     strSQL = "INSERT POLineItems VALUES(" & lngPurchID & ", 1, " & _
                              CStr(.Fields("Quantity").Value) & ", '" & CStr(.Fields("SKU").Value) & "', " & _
                              CStr(rstProd.Fields("Cost").Value) & ", 0, 0, 0, 0, 32)"
                     cnnPurchOrd.Execute strSQL, lngReccnt, adCmdText
                     
                     If CLng(lngReccnt) = 0 Then
                        cnnPurchOrd.RollbackTrans
                        strSQL = "UPDATE LineItems SET StatusID = 99 "
                        strStatus = "99"
                     Else
                        cnnPurchOrd.CommitTrans
                        strSQL = "UPDATE LineItems SET StatusID = 42 "
                        strStatus = "42"
                        'Distibutors with POs for this order
                        strDistList = strDistList & CStr(.Fields("OrderFrom").Value) & " " & CStr(bytNumInvoices) & " "
                     End If
                  End If
                  rstTemp.Close
               End If
               cnnPurchOrd.Close
            ElseIf InStr(strDistList, CStr(.Fields("OrderFrom").Value)) > 0 Then
               'Add a line item for multiple outsourced items to the same distributor
               'This rarely occurs and isn't in the original transaction
               strSQL = "SELECT PurchID FROM PurchaseOrders " & _
                        "WHERE ReferenceID = " & CStr(lngOrderID) & _
                        " AND DistID = '" & CStr(.Fields("OrderFrom").Value) & "'"
               Set rstTemp = cnnProd.Execute(strSQL, lngReccnt, adCmdText)
               If Not rstTemp.EOF Then
                  lngPurchID = CLng(rstTemp.Fields(0).Value)
                  strSQL = "SELECT COUNT(PurchID) FROM POLineItems WHERE PurchID = " & CStr(lngPurchID)
                  Set rstTemp = cnnProd.Execute(strSQL, , adCmdText)
                  If Not rstTemp.EOF Then
                     bytItem = CByte(rstTemp.Fields(0).Value)
                     bytItem = bytItem + 1
                  End If
                  rstTemp.Close
               End If
               If lngPurchID = 0 Or bytItem = 0 Then
                  strSQL = "UPDATE LineItems SET StatusID = 99 "
               Else
                  strSQL = "INSERT POLineItems VALUES(" & lngPurchID & ", " & CStr(bytItem) & ", " & _
                           CStr(.Fields("Quantity").Value) & ", '" & _
                           CStr(.Fields("SKU").Value) & "', " & _
                           CStr(rstProd.Fields("Cost").Value) & ", 0, 0, 0, 0, 32)"
                  cnnProd.Execute strSQL, lngReccnt, adCmdText
                  
                  If CLng(lngReccnt) = 0 Then
                     strSQL = "UPDATE LineItems SET StatusID = 99 "
                     strStatus = "99"
                  Else
                     strSQL = "UPDATE LineItems SET StatusID = 42 "
                     strStatus = "42"
                  End If
               End If
            End If
         End If
         .MoveNext
      Loop
      .Close
   End With
   
   'Calculate total charge for shipment, including freight and sales tax (if applicable)
   curOrderTotal = 0
   For bytInv = 1 To bytNumInvoices
      curOrderTotal = curOrderTotal + CCur((acurItemsTotal(bytInv) + acurFreight(bytInv) + CCur(Round(acurSalesTax(bytInv), 2))))
   Next bytInv
   
   'Remove/Reduce hold, charge card
   If blnUseWS Then
      If blnUseOakLeaf Then
         'Use OakLeaf's remote Web service
         If blnUseIP Then
            'Test time difference with DNS lookup
            strURL = "http://" & strNetIP & "/omega/OmegaBank.wsdl"
         Else
            strURL = "http://www.oakleaf.ws/omega/OmegaBank.wsdl"
         End If
         'oakleaf.ws server
         strServer = "OAKLEAF-MS7"
      Else
         strURL = "http://localhost/Omega/OmegaBank.wsdl"
         strServer = strNetServer
      End If
      Set objOmegaBank = CreateObject("MSSOAP.SoapClient")
      objOmegaBank.ClientProperty("ServerHTTPRequest") = True
      Call objOmegaBank.mssoapinit(strURL)
      strCharge = objOmegaBank.ChargeOrCredit(strServer, strNetUser, strNetPwd, 151203, _
                  lngOrderID, strCardNumber, lngTransactID, CSng(curOrderTotal), blnAllInStock, False, blnUseWS)
      If Len(objOmegaBank.faultstring) > 0 Then
         strCharge = "ERROR: " & objOmegaBank.faultstring
         GoTo ExitShipItems
      End If
      Set objOmegaBank = Nothing
   Else
      strCharge = OmegaBank.ChargeOrCredit(strNetServer, strNetUser, strNetPwd, 151203, _
                  lngOrderID, strCardNumber, lngTransactID, CSng(curOrderTotal), blnAllInStock, False, blnUseWS)
      Set OmegaBank = Nothing
   End If
   If InStr(UCase$(strCharge), "ERROR") > 0 Then
      ShipItems = strCharge
      GoTo ExitShipItems
   ElseIf Err.Number <> 0 Then
      ShipItems = "ERROR: " & Err.Description
      GoTo ExitShipItems
   End If
  
   'Update the order status
   If InStr(strCharge, "(") > 0 Then
      strStatus = Mid$(strCharge, InStr(strCharge, "(") + 1)
      If InStr(strStatus, ")") > 0 Then
         strStatus = Left$(strStatus, InStr(strStatus, ")") - 1)
         strCharge = Mid$(strCharge, InStr(strCharge, " ") + 1)
         If InStr(strCharge, " TRID ") > 0 Then
            strTRID = Mid$(strCharge, InStr(strCharge, " TRID ") + 6)
            strTRID = Left$(strTRID, InStr(strTRID, " ") - 1)
         Else
            strErrMsg = "Invalid OmegaBank status value"
            GoTo ExitShipItems
         End If
      Else
         strErrMsg = "Invalid OmegaBank status value"
         GoTo ExitShipItems
      End If
   Else
      strErrMsg = "Invalid OmegaBank status value"
      GoTo ExitShipItems
   End If
   lngReccnt = 0
   
   If strStatus = "32" Then
      If blnAllInStock Then
         strStatus = "59" 'Shipment Complete
         strMsg = "Shipment Complete"
      Else
         'Todo: Check for prior partial shipments
         strStatus = "51"
         strMsg = "Partial Shipment 1"
      End If
      strSQL = "UPDATE Orders SET StatusID = " & strStatus & ", " & _
               "LastStatusUpdate = '" & CStr(Now()) & "', LastStatusMessage = '" & _
               strMsg & "', CCTransactionID = " & strTRID & _
               " WHERE OrderID = " & CStr(lngOrderID)
      cnnCust.Execute strSQL, lngReccnt, adCmdText
      If CLng(lngReccnt) = 0 Then
         strErrMsg = "Couldn't update record for order " & CStr(lngOrderID)
         GoTo ExitShipItems
      End If
      
      If bytNumInvoices > 0 Then
         'Transaction starts here
         With cnnInvoice
            .Open strCustConn
            .CommandTimeout = 10
            .BeginTrans
         End With
         
         'Generate invoice(s)
         With rstOrder
            For bytInv = 1 To bytNumInvoices
               If astrShipTypeID(bytInv) = "" Then
                  'Safety net for bytNumInvoices too large (shouldn't occur)
                  Exit For
               End If
               'Insert the invoice(s)
               strSQL = "INSERT Invoices(OrderID, CustID, OrderDate, ShipDate, ShipTypeID, TrackingID, " & _
                        "ShippingCharge, SalesTax, PartialShipment, CardDigits, ShipToID, StatusID, CCTransactionID) " & _
                        "VALUES(" & CStr(.Fields("OrderID").Value) & ", " & CStr(.Fields("CustID").Value) & ", '" & _
                        CStr(.Fields("OrderDate").Value) & "', '" & CStr(Now) & "', " & astrShipTypeID(bytInv) & ", '" & _
                        Trim$(astrTrackingID(bytInv)) & "', " & CStr(acurFreight(bytInv)) & ", " & _
                        CStr(acurSalesTax(bytInv)) & ", " & strPartShip & ", '" & Right$(strCardNumber, 4) & "', " & _
                        CStr(.Fields("ShipToID").Value) & ", " & strStatus & ", " & strTRID & ")"
               cnnInvoice.Execute strSQL, lngReccnt, adCmdText
               
               If CLng(lngReccnt) = 1 Then
                  'Get the proposed invoice number
                  strSQL = "SELECT @@identity"
                  Set rstInvoice = cnnInvoice.Execute(strSQL, lngReccnt, adCmdText)
                  If rstInvoice.EOF Then
                     cnnInvoice.RollbackTrans
                     strErrMsg = "Couldn't obtain InvoiceID for invoice " & CStr(bytNumInvoices)
                     GoTo ExitShipItems
                  Else
                     lngInvoiceID = CLng(rstInvoice.Fields(0).Value)
                     alngPurchInvID(bytInv, 2) = lngInvoiceID
                     strSQL = "INSERT OrdersInvoices VALUES(" & CStr(rstOrder.Fields("OrderID").Value) & ", " & CStr(lngInvoiceID) & ")"
                     cnnInvoice.Execute strSQL, lngReccnt, adCmdText
                     If CLng(lngReccnt) <> 1 Then
                        cnnInvoice.RollbackTrans
                        strErrMsg = "Couldn't add OrdersInvoices record for invoice " & CStr(bytNumInvoices)
                        GoTo ExitShipItems
                     End If
                     rstInvoice.Close
                  End If
               Else
                  cnnInvoice.RollbackTrans
                  strErrMsg = "Couldn't add invoice " & CStr(bytNumInvoices)
                  GoTo ExitShipItems
               End If
            Next bytInv
         End With
         'Commit all invoices at once
         cnnInvoice.CommitTrans
        
         'The following must be done after committing the transaction
         'to avoid a major-scale SQL Server performance hit
         For bytInv = 1 To bytNumInvoices
            If alngPurchInvID(bytInv, 1) > 0 Then
               'Serialize the invoice
               lngPurchID = alngPurchInvID(bytInv, 1)
               lngInvoiceID = alngPurchInvID(bytInv, 2)
               strSQL = "SELECT * FROM Invoices WHERE InvoiceID = " & lngInvoiceID
               Set rstInvoice = cnnCust.Execute(strSQL, , adCmdText)
               
               strXML = SerializeCustInvoice(lngInvoiceID, lngOrderID, cnnCust, _
                                             cnnProd, rstInvoice, rstCust, rstShipTo, strDistID)
              
               If InStr(strXML, "Error:") = 0 Then
                  'Text might contain "'", fix occurrences
                  strXML = Replace$(strXML, "'", "''")
                  'Add the serialized invoice to the purchase order to preserve it
                  strSQL = "UPDATE PurchaseOrders SET CustInvoice = '" & strXML & _
                           "' WHERE PurchID = " & CStr(lngPurchID)
                  cnnProd.Execute strSQL, lngReccnt, adCmdText
                  If CLng(lngReccnt) = 1 Then
                     'Format the order as XML and send it to the distributor
                     strXML = ""
                     strXML = SendPurchaseOrder(strProdServer, strProdUser, _
                                                strProdPwd, lngPurchID, _
                                                blnUseWS, blnUseOakLeaf, blnUseIP)
                     If Len(strXML) < 100 Then
                        'Error
                     End If
                  Else
                     'Error
                  End If
               Else
                  'Error
               End If
            End If
         Next bytInv
      End If
   Else
      strErrMsg = "Error: Order status <> 32"
   End If
   
ExitShipItems:
   If Len(strErrMsg) Then
      Dim UpdateOrder As New clsUpdateOrder
      'Todo: Should rollback credit-card charge
      'Place order and line items in suspend state
      intSuspend = UpdateOrder.UpdateOrderStatus(strCustServer, strCustUser, strCustPwd, _
                                                 lngOrderID, 99, CStr(lngOrderID) & " " & strErrMsg, 0)
      ShipItems = "Error: Can't generate invoice" & strErrMsg & " (transaction rolled back)"
      Set UpdateOrder = Nothing
   ElseIf bytNumInvoices > 0 Then
      If bytNumInvoices > 1 Then
         ShipItems = CStr(bytNumInvoices) & " invoices "
      Else
         ShipItems = "Invoice "
      End If
      ShipItems = ShipItems & " issued for " & Format$(curOrderTotal, "$#,##0.00") & "; card charged"
      If blnAllInStock Then
         ShipItems = ShipItems & " (order complete)"
      Else
         ShipItems = ShipItems & " (partial shipment)"
      End If
   End If
   
   'Cleanup
   With rstCust
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstCust = Nothing
   With rstOrder
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstOrder = Nothing
   With rstItems
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstItems = Nothing
   With rstProd
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstProd = Nothing
   With rstShipTo
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstShipTo = Nothing
   With rstTemp
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstTemp = Nothing
   With rstInvoice
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstInvoice = Nothing
   With cnnCust
      If .State = adStateOpen Then
         .Close
      End If
      Set cnnCust = Nothing
   End With
   With cnnProd
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnProd = Nothing
   With cnnInvoice
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnInvoice = Nothing
   With cnnPurchOrd
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnPurchOrd = Nothing
   
End Function

Private Function GetItemFreight(ByVal strZipCode As String, _
                                ByVal sngWeight As Single, _
                                ByVal blnGetUPSCharge As Boolean) As Currency
   
   'Get freight charge for each item shipped
   Dim UPSCharges As New clsShipCost
   Dim strUPSResult As String
                                
   On Error Resume Next
   
   'Fix ZIP Code
   If InStr(strZipCode, "-") > 0 Then
      strZipCode = Left$(strZipCode, InStr(strZipCode, "-") - 1)
   End If
   
   GetItemFreight = 0
   If sngWeight > 50 Or Not blnGetUPSCharge Then
      '$0.50 per pound
      GetItemFreight = CCur(0.5 * sngWeight)
   Else
      strUPSResult = UPSCharges.GetUPSCost("GND", strZipCode, CInt(sngWeight) + 1)
      If Val(strUPSResult) > 0 Then
         GetItemFreight = CCur(Val(strUPSResult))
      Else
         'Error
         GetItemFreight = -1
      End If
   End If
   Set UPSCharges = Nothing
End Function

Private Function SerializeCustInvoice(ByVal lngInvoiceID As Long, _
                                      ByVal lngOrderID As Long, _
                                      ByRef cnnCust As ADODB.Connection, _
                                      ByRef cnnProd As ADODB.Connection, _
                                      ByRef rstInvoice As ADODB.Recordset, _
                                      ByRef rstCust As ADODB.Recordset, _
                                      ByRef rstShipTo As ADODB.Recordset, _
                                      ByRef strDistID As String) As String

   'Distributors require customer invoices (packing lists) in a standardized XML
   'format for printing and enclosure in shipment
   'Implemented as Private Function to reduce length of ShipItems function
   
   Dim rstItems As New ADODB.Recordset
   Dim rstProd As New ADODB.Recordset
   
   Dim strXML As String
   Dim intCol As Integer
   Dim strSQL As String
   
   On Error Resume Next
   
   With rstInvoice
      If .EOF Then
         strXML = "Error: Can't find invoice " & lngInvoiceID
      Else
         'Serialize the invoice, starting with invoice header
         strXML = "   <CustomerInvoice>" & vbCrLf & Space$(6) & "<Header>" & vbCrLf
         For intCol = 0 To CInt(.Fields.Count) - 2
            strXML = strXML & Space$(9) & "<" & CStr(.Fields(intCol).Name) & _
                     ">" & CStr(.Fields(intCol).Value) & _
                     "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
         Next intCol
         strXML = strXML & Space(6) & "</Header>" & vbCrLf & Space(6) & "<BillingAddr>" & vbCrLf
         
         'Add billing address
         With rstCust
            'Combine first and last name
            strXML = strXML & Space$(9) & "<Name>" & CStr(.Fields(1).Value) & _
                     " " & CStr(.Fields(2).Value) & "</Name>" & vbCrLf
            
            For intCol = 3 To 6
            strXML = strXML & Space$(9) & "<" & CStr(.Fields(intCol).Name) & _
                     ">" & CStr(.Fields(intCol).Value) & _
                     "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
            Next intCol
         End With
         strXML = strXML & Space(6) & "</BillingAddr>" & vbCrLf & Space(6) & "<ShippingAddr>" & vbCrLf
         
         'Add shipping address
         With rstShipTo
            For intCol = 2 To CInt(.Fields.Count) - 1
            strXML = strXML & Space$(9) & "<Ship" & CStr(.Fields(intCol).Name) & _
                     ">" & CStr(.Fields(intCol).Value) & _
                     "</Ship" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
            Next intCol
         End With
         strXML = strXML & Space(6) & "</ShippingAddr>" & vbCrLf & Space(6) & "<LineItems>" & vbCrLf
         
         'Add outsourced line items
         strSQL = "SELECT * FROM LineItems WHERE OrderID = " & lngOrderID
         Set rstItems = cnnCust.Execute(strSQL, , adCmdText)
         With rstItems
            Do Until .EOF
               If CBool(.Fields("Outsourced").Value) Then
                  If CStr(.Fields("OrderFrom").Value) = strDistID Then
                     'Item is outsourced to this distributor, get product info
                     strSQL = "SELECT BrandID, Model, Description FROM Products " & _
                              "WHERE SKU = '" & CStr(.Fields(3).Value) & "'"
                     Set rstProd = cnnProd.Execute(strSQL, , adCmdText)
                     If rstProd.EOF Then
                        strXML = "Error: Can't find product record"
                     Else
                        strXML = strXML & Space$(9) & "<Item>" & vbCrLf
                        'Add ItemID, Quantity, SKU
                        For intCol = 1 To 3
                           strXML = strXML & Space$(12) & "<" & CStr(.Fields(intCol).Name) & _
                                    ">" & CStr(.Fields(intCol).Value) & _
                                    "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                        Next intCol
                           
                        'Add BrandID, Model, Description
                        For intCol = 0 To 2
                           strXML = strXML & Space$(12) & "<" & CStr(rstProd.Fields(intCol).Name) & _
                                    ">" & CStr(rstProd.Fields(intCol).Value) & _
                                    "</" & CStr(rstProd.Fields(intCol).Name) & ">" & vbCrLf
                        Next intCol
                        
                        'Add UnitPrice, Discount, etc.
                        For intCol = 5 To CInt(.Fields.Count) - 4
                           strXML = strXML & Space$(12) & "<" & CStr(.Fields(intCol).Name) & _
                                    ">" & CStr(.Fields(intCol).Value) & _
                                    "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                        Next intCol
                        strXML = strXML & Space$(9) & "</Item>" & vbCrLf
                     End If
                  End If
               End If
               .MoveNext
            Loop
         End With
         If InStr(strXML, "Error:") = 0 Then
            '& appears occasionally in addresses
            strXML = Replace$(strXML, "&", "and")
            strXML = strXML & Space(6) & "</LineItems> " & vbCrLf & "   </CustomerInvoice>"
         End If
      End If
   End With
   SerializeCustInvoice = strXML
End Function


Private Function SendPurchaseOrder(ByVal strProdServer As String, _
                                   ByVal strProdUser As String, _
                                   ByVal strProdPwd As String, _
                                   ByVal lngPurchID As Long, _
                                   ByVal blnUseWS As Boolean, _
                                   ByVal blnUseOakLeaf As Boolean, _
                                   ByVal blnUseIP As Boolean) As String
   
   'Transmit purchase orders for outsourced items or to replenish inventory
   'All distributors require a standard XML format, with or without
   '<CustomerInvoice> elements
   Dim cnnOrder As New ADODB.Connection
   Dim rstOrder As New ADODB.Recordset
   Dim rstItems As New ADODB.Recordset
   Dim rstDist As New ADODB.Recordset
   Dim docOrder As New MSXML2.DOMDocument40
   'Dim objSoapClient As New SoapClient
   Dim objSoapClient As Object
      
   Dim strProdConn As String
   Dim strSQL As String
   Dim intCol As Integer
   Dim strXML As String
   Dim strServer As String
   Dim strDatabase As String
   Dim strUserName As String
   Dim strPassword As String
   Dim strOrderURL As String
   Dim strServiceURL As String
   Dim strResponse As String
   
   On Error Resume Next
   
   'Connect to the production database
   strProdConn = "Provider=SQLOLEDB;Data Source=" & strProdServer & _
      ";Initial Catalog=OCE_Prod;UID=" & strProdUser & ";PWD=" & strProdPwd
   cnnOrder.Open strProdConn
   
   With cnnOrder
      'Get the purchase order
      strSQL = "SELECT * FROM PurchaseOrders WHERE PurchID = " & CStr(lngPurchID)
      Set rstOrder = .Execute(strSQL, , adCmdText)
      If rstOrder.EOF Then
         SendPurchaseOrder = "Error: Can't find PO# " & CStr(lngPurchID)
      Else
         'Get the distributor connection data
         strSQL = "SELECT ServerName, [Database], UserName, Password, OrderWS " & _
                  "FROM Distributors WHERE DistID = '" & CStr(rstOrder.Fields(2).Value) & "'"
         Set rstDist = .Execute(strSQL, , adCmdText)
         If rstDist.EOF Then
            SendPurchaseOrder = "Error: Can't find distributor code " & CStr(rstOrder.Fields(2).Value)
         Else
            With rstDist
               strServer = CStr(.Fields(0).Value)
               strDatabase = CStr(.Fields(1).Value)
               strUserName = CStr(.Fields(2).Value)
               strPassword = CStr(.Fields(3).Value)
               strOrderURL = CStr(.Fields(4).Value)
            End With
            
            'Get the purchase order line items
            strSQL = "SELECT * FROM POLineItems WHERE PurchID = " & CStr(lngPurchID)
            Set rstItems = .Execute(strSQL, , adCmdText)
            If rstItems.EOF Then
               SendPurchaseOrder = "Error: Can't find line items for PO# " & CStr(lngPurchID)
            Else
               With rstOrder
                  strXML = "<PurchaseOrder>" & vbCrLf & "   <Header>" & vbCrLf
                  For intCol = 0 To CInt(.Fields.Count) - 2
                     If intCol < 2 Or intCol = 3 Or intCol = 5 Or intCol > 10 Then
                        strXML = strXML & Space$(6) & "<" & CStr(.Fields(intCol).Name) & ">"
                        If intCol = 5 Then
                           'Remove the time
                           If InStr(CStr(.Fields(intCol).Value), " ") > 0 Then
                              'strXML = strXML & Left$(CStr(.Fields(intCol).Value), InStr(CStr(.Fields(intCol).Value), " ") - 1)
                           End If
                        Else
                           strXML = strXML & CStr(.Fields(intCol).Value)
                        End If
                        strXML = strXML & "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                     End If
                  Next intCol
                  strXML = strXML & "   </Header>" & vbCrLf
                  strXML = strXML & "   <BillingAddr>" & vbCrLf
                  strXML = strXML & Space$(6) & "<CompanyName>OakLeaf Consumer Electronics</CompanyName>" & vbCrLf
                  strXML = strXML & Space$(6) & "<Attention>Accounts Payable</Attention>" & vbCrLf
                  strXML = strXML & Space$(6) & "<Address>415 W. Jefferson</Address>" & vbCrLf
                  strXML = strXML & Space$(6) & "<City>Dallas</City>" & vbCrLf
                  strXML = strXML & Space$(6) & "<State>TX</State>" & vbCrLf
                  strXML = strXML & Space$(6) & "<ZIPCode>75208</ZIPCode>" & vbCrLf
                  strXML = strXML & Space$(6) & "<Phone>214-555-2345</Phone>" & vbCrLf
                  strXML = strXML & "   </BillingAddr>" & vbCrLf
                  strXML = strXML & "   <ShippingAddr>" & vbCrLf
                  If CBool(.Fields("ShipToCustomer").Value) Then
                     For intCol = 6 To 10
                        strXML = strXML & Space$(6) & "<" & CStr(.Fields(intCol).Name) & _
                                 ">" & CStr(.Fields(intCol).Value) & _
                                 "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                        If intCol = 6 Then
                           'Not for customer shipments
                           strXML = strXML & Space$(6) & "<ShipAttn></ShipAttn>" & vbCrLf
                        End If
                     Next intCol
                  Else
                     strXML = strXML & Space$(6) & "<ShipName>OakLeaf Consumer Electronics</ShipName>" & vbCrLf
                     strXML = strXML & Space$(6) & "<ShipAttn>Receiving Dept.</ShipAttn>" & vbCrLf
                     strXML = strXML & Space$(6) & "<ShipAddress>2623 S Garland Ave.</ShipAddress>" & vbCrLf
                     strXML = strXML & Space$(6) & "<ShipCity>Garland</ShipCity>" & vbCrLf
                     strXML = strXML & Space$(6) & "<ShipState>TX</ShipState>" & vbCrLf
                     strXML = strXML & Space$(6) & "<ShipZIPCode>75041</ShipZIPCode>" & vbCrLf
                     strXML = strXML & Space$(6) & "<ShipPhone>972-555-1234</ShipPhone>" & vbCrLf
                  End If
                  strXML = strXML & "   </ShippingAddr>" & vbCrLf
                  strXML = strXML & "   <LineItems>" & vbCrLf
                  With rstItems
                     Do Until .EOF
                        strXML = strXML & Space$(6) & "<Item>" & vbCrLf
                        For intCol = 1 To CInt(.Fields.Count) - 1
                           strXML = strXML & Space$(9) & "<" & CStr(.Fields(intCol).Name) & _
                                    ">" & CStr(.Fields(intCol).Value) & _
                                    "</" & CStr(.Fields(intCol).Name) & ">" & vbCrLf
                        Next intCol
                        strXML = strXML & Space$(6) & "</Item>" & vbCrLf
                        .MoveNext
                     Loop
                  End With
                  strXML = strXML & "   </LineItems>" & vbCrLf
                  If CBool(.Fields("ShipToCustomer").Value) Then
                     'Fix escaped "'", if present
                     strXML = strXML & Replace$(CStr(.Fields("CustInvoice").Value), "''", "'")
                  End If
                  strXML = strXML & vbCrLf & "</PurchaseOrder>" & vbCrLf
               End With
            End If
         End If
      End If
   End With
   'Escape "&" with "and", not an entity
   strXML = Replace$(strXML, "&", "and")

   'Check wellformedness and send the order to the distributor
   With docOrder
      If blnUseOakLeaf Then
         If blnUseIP Then
            'Same IPs for all distributors
            strServiceURL = "http://66.123.163.243/"
         Else
            strServiceURL = "http://www.oakleaf.ws/"
         End If
      Else
         strServiceURL = "http://localhost/"
      End If
      
      'Test for parse errors
      .loadXML strXML
      If .parseError.errorCode = 0 Then
         Select Case strDatabase
            Case "AlphaDist"
               If blnUseWS Then
                  strServiceURL = strServiceURL & "Alpha/AlphaDist.wsdl"
               Else
                  Dim objAlphaOrder As New clsAlphaDist
                  strXML = objAlphaOrder.PlaceOrder(strServer, strDatabase, _
                           strUserName, strPassword, strXML, False)
                  Set objAlphaOrder = Nothing
               End If
            Case "BetaDist"
               If blnUseWS Then
                  strServiceURL = strServiceURL & "Beta/BetaDist.wsdl"
               Else
                  Dim objBetaOrder As New clsBetaDist
                  strXML = objBetaOrder.PlaceOrder(strServer, strDatabase, _
                           strUserName, strPassword, strXML, False)
                  Set objBetaOrder = Nothing
               End If
            Case "GammaDist"
               If blnUseWS Then
                  strServiceURL = strServiceURL & "Gamma/GammaDist.wsdl"
               Else
                  Dim objGammaOrder As New clsGammaDist
                  strXML = objGammaOrder.PlaceOrder(strServer, strDatabase, _
                           strUserName, strPassword, strXML, False)
                  Set objGammaOrder = Nothing
               End If
         End Select
         If blnUseWS Then
            'Late binding for multi-purpose use
            Set objSoapClient = CreateObject("MSSOAP.SoapClient")
            Call objSoapClient.mssoapinit(strServiceURL)
            'ToDo: Change to XML return string after testing
            strResponse = objSoapClient.PlaceOrder(strServer, strDatabase, _
                          strUserName, strPassword, strXML, True)
            If Len(objSoapClient.faultstring) > 0 Then
               SendPurchaseOrder = "ERROR: " & objSoapClient.faultstring
            End If
            Set objSoapClient = Nothing

            If Err.Number = 0 And Len(SendPurchaseOrder) = 0 Then
               .loadXML strResponse
               If .parseError.errorCode = 0 Then
                  SendPurchaseOrder = strResponse
               Else
                  SendPurchaseOrder = "Error: Parse error '" & _
                     .parseError.reason & "' in response document from " & strDatabase & "."
               End If
            ElseIf Err.Number <> 0 Then
               SendPurchaseOrder = "ERROR: " & Err.Description
            End If
         Else
            If Err.Number = 0 Then
               SendPurchaseOrder = strResponse
            Else
               SendPurchaseOrder = "ERROR: " & Err.Description
            End If
         End If
      Else
         SendPurchaseOrder = "Error: Parse error '" & .parseError.reason & "' in order document."
      End If
   End With

   'Clean up
   Set docOrder = Nothing
   rstOrder.Close
   Set rstOrder = Nothing
   rstItems.Close
   Set rstItems = Nothing
   rstDist.Close
   Set rstDist = Nothing
   cnnOrder.Close
   Set cnnOrder = Nothing
End Function

