VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsOmegaBank"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Function VerifyOrHold(ByVal strServer As String, _
                             ByVal strUser As String, _
                             ByVal strPwd As String, _
                             ByVal lngMerchantID As Long, _
                             ByVal lngRefNum As Long, _
                             ByVal strIssuer As String, _
                             ByVal strCardNumber As String, _
                             ByVal strCardName As String, _
                             ByVal strZipCode As String, _
                             ByVal strExpDate As String, _
                             ByVal curTransactAmt As Currency, _
                             ByVal blnApplyHold As Boolean, _
                             ByVal blnUseWS As Boolean) As String
   
   'Verify credit card data, credit availability, and apply holds
   'Returns a string with denied or approved information
   
   Dim cnnVerify As New ADODB.Connection
   Dim rstVerify As New ADODB.Recordset
   
   Dim strNetConn As String
   Dim strSQL As String
   Dim strExpMonth As String
   Dim strExpYear As String
   Dim datExpDate As Date
   Dim lngTransactID As Long
   Dim lngReccnt As Long
   Dim strDateTime As String
   Dim curAvailable As Currency
   'Dim curTransactAmt As Currency
   
   On Error Resume Next
   
   'curTransactAmt = CCur(sngTransactAmt)
   
   strNetConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
      ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
   cnnVerify.Open strNetConn
   If Err.Number <> 0 Then
      VerifyOrHold = "ERROR: " & Err.Description & " (" & Err.Number & ")"
      GoTo exitVerifyOrHold
   End If
   
   'Check merchant account
   strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & _
            "WHERE MerchantID = " & CStr(lngMerchantID)
   Set rstVerify = cnnVerify.Execute(strSQL, , adCmdText)
   With rstVerify
      If CLng(.Fields(0)) = 0 Then
         VerifyOrHold = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
         GoTo exitVerifyOrHold
      Else
         .Close
      End If
   End With
   
   'Check credit-card status
   strSQL = "SELECT Canceled, Issuer, CardName, ZipCode, ExpDate, Available " & _
            "FROM Authorize WHERE CardNumber = '" & strCardNumber & "'"
   Set rstVerify = cnnVerify.Execute(strSQL, , adCmdText)
   With rstVerify
      If .EOF Then
         VerifyOrHold = CStr(lngRefNum) & " Error: " & strIssuer & " Card number " & strCardNumber & " not found (0)."
      Else
         'Calculate expiration date
         strExpDate = CStr(.Fields(4).Value)
         strExpMonth = Val(Left(strExpDate, 2))
         strExpYear = Val(Right(strExpDate, 2))
         If strExpMonth = 12 Then
            strExpYear = strExpYear + 1
         End If
         datExpDate = CDate(strExpMonth & "/01/" & strExpYear)
         curAvailable = CCur(.Fields(5).Value)
         
         'Initial credit-card check
         If CByte(.Fields(0)) = 1 Then
            VerifyOrHold = CStr(lngRefNum) & " Declined: " & strIssuer & " " & strCardNumber & " is canceled (19)"
         ElseIf CStr(.Fields(1)) <> strIssuer Then
            VerifyOrHold = CStr(lngRefNum) & " Declined: Issuer mismatch (18)"
         ElseIf CStr(.Fields(2)) <> strCardName Then
            VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder name mismatch (17)"
         ElseIf CStr(.Fields(3)) <> strZipCode Then
            VerifyOrHold = CStr(lngRefNum) & " Declined: Cardholder ZIP Code mismatch (16)"
         ElseIf CStr(.Fields(4)) <> strExpDate Then
            VerifyOrHold = CStr(lngRefNum) & " Declined: Expiration date mismatch (15)"
         ElseIf DateDiff("d", Date, datExpDate) < 1 Then
            VerifyOrHold = CStr(lngRefNum) & " Declined: Card expired " & CStr(.Fields(4)) & " (13)"
         End If
      End If
   End With
   rstVerify.Close
   If Len(VerifyOrHold) > 0 Then
      GoTo exitVerifyOrHold
   End If
   
   'Get current available credit
   strSQL = "SELECT SUM(Amount) FROM Transactions WHERE CardNumber = '" & _
            strCardNumber & "' AND AppliedToStatement IS NULL"
   Set rstVerify = cnnVerify.Execute(strSQL, , adCmdText)
   With rstVerify
      If Not .EOF Then
         'Holds and charges are negative values
         If Not IsNull(.Fields(0).Value) Then
            curAvailable = curAvailable + CCur(.Fields(0).Value)
         End If
      End If
   End With

   'Check available credit
   If curAvailable < curTransactAmt Then
      VerifyOrHold = CStr(lngRefNum) & " Declined: Insufficient credit available (14)"
      GoTo exitVerifyOrHold
   Else
      VerifyOrHold = CStr(lngRefNum) & " Verify Code: " & CStr(Int(1000 * Rnd)) & "OMB" & CStr(Int(100000 * Rnd)) & " (12)"
   End If
   
   If blnApplyHold Then
      'Change to debit
      curTransactAmt = -curTransactAmt
      strDateTime = CStr(Now)
      'TypeID 31 is "Hold applied by merchant"
      strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & _
               "TransactionDate, TransactionTypeID, Amount) " & _
               "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & _
               strCardNumber & "', '" & strDateTime & "', 31, " & CStr(curTransactAmt) & ")"
      cnnVerify.Execute strSQL, lngReccnt, adCmdText
      If CLng(lngReccnt) = 1 Then
         strSQL = "SELECT TransactionID FROM Transactions " & _
                  "WHERE Reference = " & CStr(lngRefNum) & _
                  " AND TransactionDate = '" & strDateTime & "'"
         Set rstVerify = cnnVerify.Execute(strSQL, , adCmdText)
         With rstVerify
            If .EOF Then
               VerifyOrHold = CStr(lngRefNum) & " Error: Unable to apply hold (99)"
            Else
               lngTransactID = CLng(.Fields(0).Value)
               VerifyOrHold = CStr(lngRefNum) & " Hold on " & Format$(-curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (12)"
            End If
            .Close
         End With
      Else
         VerifyOrHold = CStr(lngRefNum) & " Error: Unable to apply hold (99)"
      End If
   End If
   
exitVerifyOrHold:
   'Clean up
   With rstVerify
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstVerify = Nothing
   With cnnVerify
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnVerify = Nothing
End Function

Public Function ChargeOrCredit(ByVal strServer As String, _
                               ByVal strUser As String, _
                               ByVal strPwd As String, _
                               ByVal lngMerchantID As Long, _
                               ByVal lngRefNum As Long, _
                               ByVal strCardNumber As String, _
                               ByVal lngRelTransactID As Long, _
                               ByVal curTransactAmt As Currency, _
                               ByVal blnReleaseHold As Boolean, _
                               ByVal blnCredit As Boolean, _
                               ByVal blnUseWS As Boolean) As String
                               
   'Release/reduce hold and charge credit card
   
   Dim cnnCharge As New ADODB.Connection
   Dim rstCharge As New ADODB.Recordset
   
   Dim strNetConn As String
   Dim strSQL As String
   Dim lngReccnt As Long
   Dim strDateTime As String
   Dim strStatusID As String
   Dim curHoldAmt As Currency
   Dim lngTransactID As Long
   
   On Error Resume Next
   
   strNetConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
      ";Initial Catalog=OMB_Network;UID=" & strUser & ";PWD=" & strPwd
   cnnCharge.Open strNetConn
   If Err.Number <> 0 Then
      ChargeOrCredit = "ERROR: " & Err.Description & " (" & Err.Number & ")"
      GoTo exitChargeOrCredit
   End If
   
   strSQL = "SELECT COUNT(MerchantID) FROM Merchants " & _
            "WHERE MerchantID = " & CStr(lngMerchantID)
   Set rstCharge = cnnCharge.Execute(strSQL, , adCmdText)
   With rstCharge
      If CLng(.Fields(0)) = 0 Then
         ChargeOrCredit = "Error: Merchant account " & CStr(lngMerchantID) & " not found."
         GoTo exitChargeOrCredit
      Else
         .Close
      End If
   End With
                                     
   strSQL = "SELECT * FROM Transactions WHERE TransactionID = " & _
            CStr(lngRelTransactID)
   Set rstCharge = cnnCharge.Execute(strSQL, , adCmdText)
   With rstCharge
      If .EOF Then
         ChargeOrCredit = "Error: Related transaction " & CStr(lngRelTransactID) & " not found."
         GoTo exitChargeOrCredit
      Else
         'TypeID 31 is "Hold applied by merchant"
         If CByte(.Fields("TransactionTypeID").Value) = 31 Then
            'More tests could be applied here
            strDateTime = CStr(Now)

            With cnnCharge
               .BeginTrans
               If blnReleaseHold Then
                  strStatusID = 35 'Hold Removed by Merchant
                  curHoldAmt = -CCur(rstCharge.Fields("Amount").Value)
               Else
                  strStatusID = 34 'Hold Reduced by Merchant
                  curHoldAmt = curTransactAmt
               End If
               strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & _
                        "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & _
                        "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & _
                        strCardNumber & "', '" & strDateTime & "', 34, " & CStr(curHoldAmt) & _
                        ", " & CStr(lngRelTransactID) & ")"
               .Execute strSQL, lngReccnt, adCmdText
               If CLng(lngReccnt) <> 1 Then
                  'Error
                  .RollbackTrans
                  ChargeOrCredit = "Error: Unable to commit transaction " & CStr(lngRelTransactID) & " not found."
                  GoTo exitChargeOrCredit
               End If
               'StatusID 32 = Debit by Merchant
               curTransactAmt = -curTransactAmt
               strSQL = "INSERT Transactions(MerchantID, Reference, CardNumber, " & _
                        "TransactionDate, TransactionTypeID, Amount, RelatedTransactionID) " & _
                        "VALUES(" & CStr(lngMerchantID) & ", " & CStr(lngRefNum) & ", '" & _
                        strCardNumber & "', '" & strDateTime & "', 32, " & CStr(curTransactAmt) & _
                        ", " & CStr(lngRelTransactID) & ")"
               .Execute strSQL, lngReccnt, adCmdText
               If CLng(lngReccnt) = 1 Then
                  .CommitTrans
               Else
                  ChargeOrCredit = CStr(lngRefNum) & " Error: Charge transaction didn't commit (99)"
                  .RollbackTrans
                  GoTo exitChargeOrCredit
               End If
            End With
         Else
            ChargeOrCredit = CStr(lngRefNum) & " Error: Status of reference transaction is not Apply Hold (99)"
            GoTo exitChargeOrCredit
         End If
      End If
   End With
   
   strSQL = "SELECT @@identity"
   Set rstCharge = cnnCharge.Execute(strSQL, , adCmdText)
   With rstCharge
      If .EOF Then
         ChargeOrCredit = CStr(lngRefNum) & " Error: Unable to obtain Transaction ID (99)"
      Else
         lngTransactID = CLng(.Fields(0).Value)
         ChargeOrCredit = CStr(lngRefNum) & " Debit " & Format$(curTransactAmt, "$#,##0.00") & " applied by TRID " & CStr(lngTransactID) & " (32)"
      End If
   End With
   
exitChargeOrCredit:
   'Clean up
   With rstCharge
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set rstCharge = Nothing
   With cnnCharge
      If .State = adStateOpen Then
         .Close
      End If
   End With
   Set cnnCharge = Nothing
End Function


