VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShipCost"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function GetUpsCost(ByVal strShipTypeCode As String, ByVal strZipCode As String, ByVal intWeight As Integer) As String
   'Use MSXML 4.0's ServerXHLHTTP to retrieve the UPS Cost
   'Much simpler than WinInet, thread-safe, and server-safe
   'Thanks to technical editor Darshan Singh for the suggestion

   Dim objHTTP As New MSXML2.ServerXMLHTTP40

   Dim strURL As String
   Dim astrReturn() As String
   Dim bytStatus As Byte

   On Error GoTo errGetUpsCost

   strURL = "http://www.ups.com/using/services/rave/qcostcgi.cgi?" & "accept_UPS_license_agreement=yes&10_action=3&13_product=" & strShipTypeCode & "&14_origCountry=US&15_origPostal=75041&19_destPostal=" & strZipCode & "&22_destCountry=US&23_weight=" & intWeight & "&49_residential=1"
   With objHTTP
      'Timeouts are 5, 5, 5, and 10 seconds (arbitrary)
      .setTimeouts 5000, 5000, 5000, 10000
      .Open "GET", strURL
      .send
      If .Status >= 400 And .Status <= 599 Then
         GetUpsCost = "Error: " & .statusText & " (-8)"
      Else
         'Split string into array
         astrReturn = Split(.responseText, "%")

         'Get the status code and return appropriate value
         bytStatus = CByte(Right(astrReturn(0), 1))
         Select Case bytStatus
            Case 3 'single product
               GetUpsCost = astrReturn(10)
            Case 4 'product range
               GetUpsCost = astrReturn(10)
            Case 5 'error
               GetUpsCost = "Error: " & astrReturn(bytStatus) & " (-5)"
            Case 6 'warning
               GetUpsCost = "Error: " & astrReturn(bytStatus) & " (-6)"
            Case Else
               GetUpsCost = "Error: Invalid response: " & bytStatus & " (-7)"
         End Select
      End If
   End With
   Exit Function

errGetUpsCost:
   GetUpsCost = "Error: " & Err.Description & " (-3)"
End Function

