VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsUpdateOrder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Function UpdateOrderStatus(ByVal strServer As String, _
                                  ByVal strUser As String, _
                                  ByVal strPwd As String, _
                                  ByVal lngOrderID As Long, _
                                  ByVal bytStatus As Byte, _
                                  ByVal strStatusMsg As String, _
                                  ByVal lngTransactID As Long) As Integer
   
   'Change status of order and line items (single transaction)
   Dim cnnUpdate As New ADODB.Connection
   Dim strUpdateConn As String
   Dim strSQLOrder As String
   Dim strSQLItems As String
   Dim lngReccnt As Long
   
   On Error Resume Next
   
   If CLng(Val(strStatusMsg)) <> lngOrderID Then
      'For synchronous execution, match is required
      UpdateOrderStatus = -4
      Exit Function
   End If
   
   'Remove the Reference value
   strStatusMsg = Mid$(strStatusMsg, InStr(strStatusMsg, " ") + 1)
   
   strUpdateConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
                   ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
   If lngTransactID = 0 Then
      strSQLOrder = "UPDATE Orders SET StatusID = " & bytStatus & ", LastStatusMessage = '" & _
                    CStr(strStatusMsg) & "', LastStatusUpdate = '" & CStr(Now()) & _
                    "' WHERE OrderID = " & CStr(lngOrderID)
   Else
      strSQLOrder = "UPDATE Orders SET StatusID = " & bytStatus & ", LastStatusMessage = '" & _
                    CStr(strStatusMsg) & "', LastStatusUpdate = '" & CStr(Now()) & "', " & _
                    "CCTransactionID = " & CStr(lngTransactID) & _
                    " WHERE OrderID = " & CStr(lngOrderID)
   End If
   strSQLItems = "UPDATE LineItems SET StatusID = " & bytStatus & _
                 " WHERE OrderID = " & CStr(lngOrderID)
                   
   With cnnUpdate
      .Open strUpdateConn
      If Err.Number <> 0 Then
         'Connection failed
         UpdateOrderStatus = -1
         Exit Function
      End If
      .BeginTrans
      .Execute strSQLOrder, lngReccnt, adCmdText
      If Err.Number <> 0 Or CLng(lngReccnt) = 0 Then
         'Order update failed
         UpdateOrderStatus = -2
         .RollbackTrans
         .Close
         Exit Function
      End If
      .Execute strSQLItems, lngReccnt, adCmdText
      If Err.Number <> 0 Or CLng(lngReccnt) = 0 Then
         'Line items update failed
         UpdateOrderStatus = -3
         .RollbackTrans
         .Close
      Else
         .CommitTrans
         'Order plus line items
         UpdateOrderStatus = CInt(lngReccnt) + 1
      End If
   End With
End Function

Public Function DeleteLineItem(ByVal strServer As String, _
                               ByVal strUser As String, _
                               ByVal strPwd As String, _
                               ByVal lngOrderID As Long, _
                               ByVal bytItemID As Byte) As Integer
   
   'Delete one or all line items for an order
      
   Dim cnnDelete As New ADODB.Connection
   Dim strDeleteConn As String
   Dim strSQL As String
   Dim lngReccnt As Long
   
   On Error Resume Next
   
   strDeleteConn = "Provider=SQLOLEDB;Data Source=" & strServer & _
                   ";Initial Catalog=OCE_Cust;UID=" & strUser & ";PWD=" & strPwd
   
   strSQL = "UPDATE LineItems SET Deleted = 1 WHERE OrderID = " & CStr(lngOrderID)
   If bytItemID > 0 Then
      strSQL = strSQL & " AND ItemID = " & CStr(bytItemID)
   End If
   
   With cnnDelete
      .Open strDeleteConn
      If Err.Number <> 0 Then
         'Can't connect
         DeleteLineItem = -1
         Exit Function
      End If
      .Execute strSQL, lngReccnt, adCmdText
      If Err.Number <> 0 Then
         'Can't execute
         DeleteLineItem = -2
      Else
         DeleteLineItem = CInt(lngReccnt)
      End If
      .Close
   End With
   Set cnnDelete = Nothing
End Function

